// @ myth - common - binary.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef BINARY_HEADER
#define BINARY_HEADER

// @@ include

#include "common/common.h"
#include "common/buffer.h"
#include "common/string.h"

// @@ BINARY

class BINARY : public BUFFER
{
    char LongChar[4];
    int LongState;
    char ShortChar[2];
    int ShortState;
    short CoorShort[2];
    int CoorState;
    void create();
public:
    void open(int fd);
    void open(const char* name);
    void PutChar(char c);
    void PutShort(short i);
    void PutLong(long l);
    void PutString(const char* s);
    void PutCoor(coor pos);
    bool IsShortReady();
    bool IsLongReady();
    bool IsCoorReady();
    char GetChar();
    short GetShort();
    long GetLong();
//    char* GetString(char* buffer, int size);
    STRING GetString();
    coor GetCoor();
    BINARY(buffer_mode mode, const char* name);
    BINARY(buffer_mode mode, int fd = ERROR);
};

// @@ end

#endif BINARY_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
