// @ myth - common - error.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef ERROR_HEADER
#define ERROR_HEADER

// @@ include

#include "common/common.h"
#include "common/string.h"
#include "common/buffer.h"

// @@ type

// @@@ class BUG

class BUG : BUFFER
{
public:
    void open(STRING name);
    void warning(const char* where, const char* what);
    void warning(const char* where, STRING what);
    void warning(STRING where, const char* what);
    void error(const char* where, const char* what);
    void error(const char* where, STRING what);
    void fatal(const char* where, const char* what);
    void fatal(const char* where, STRING what);
    void panic(const char* where, const char* what);
    BUG();
    ~BUG();
};

// @@ extern

extern BUG bug;

// @@ end

#endif ERROR_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:

